import React, { Component } from "react";
import { View, } from "@tarojs/components";
import UserFloatingLayer from "../../components/common/userFloatingLayer";
import { selectList, updateStatus } from '../../utils/servers/servers';
import { AtButton, } from "taro-ui";
import AccountModal from "../../components/common/accountModal";
import "taro-ui/dist/style/components/button.scss";
import "taro-ui/dist/style/components/modal.scss";
import "taro-ui/dist/style/components/input.scss";
import "taro-ui/dist/style/components/icon.scss";
import "./index.less";
import Taro from "@tarojs/taro";


class myInfo extends Component {
  constructor(props) {
    super(props);
    this.state = {
      visible: "",
      list: [],
      data: {},
    };
  }


  componentDidShow() {
    this.selectList();
  }

  // async componentDidMount() {
  //   await this.selectList();
  // }

  onPullDownRefresh() {
    this.selectList();
  }

  onReachBottom() {
    this.selectList(true);
  }

  async selectList(lv) {
    await this.getMyList(lv ? this.state.pageNo + 1 : 1);
    Taro.stopPullDownRefresh();
  }

  editAccount(info) {
    this.setState({
      data: info,
      visible: "edit",
    })
  }

  onClose() {
    this.selectList();
    this.setState({
      data: {},
      visible: ""
    })
  }

  // 账户列表
  async getMyList(pageNo) {
    this.setState({
      listState: 'LOADING'
    })
    let data = {
      pageNo: pageNo,
      pageSize: 10,
    }
    let msg = await selectList(data);
    if (msg.error.length === 0) {
      if (msg.data.totalCount === 0) {
        this.setState({
          listState: 'NO_DATA'
        })
      } else if (msg.data.totalCount === this.state.list.length && pageNo !== 1) {
        // 防止提示挡住驳回弹窗
        // !this.state.isOpen && 
        Taro.showToast({ title: '没有更多了', icon: 'none' });
        this.setState({
          listState: 'NO_MORE_DATA'
        })
      } else {
        if (msg.data.totalCount === (pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list)).length) {
          this.setState({
            listState: 'NO_MORE_DATA'
          })
        }
      }
      this.setState({
        list: pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list),
        pageNo: msg.data.list.length === 0 ? this.state.pageNo : msg.data.pageNo
      })
    } else {
      Taro.showToast({ title: msg.error[0].message, icon: 'none' });
      this.setState({
        listState: msg.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
      })
    }
    Taro.stopPullDownRefresh();
  }


  // 设置默认
  onUpdateStatus(id) {
    updateStatus({
      id,
      status: 1,
    }).then(v => {
      Taro.hideLoading()
      if (v.error.length === 0) {
        Taro.showToast({ title: '设置成功', icon: 'none' });
        this.selectList();
      } else {
        Taro.showToast({ title: v.error[0].message, icon: 'none' })
      }
    }).catch(() => {
      Taro.showToast({
        title: '系统错误,请稍后再试',
        icon: 'none'
      })
    })
  }

  render() {
    const { visible, list, data } = this.state
    return (
      <View className="myinfo">
        {/* <View className="head">
          <UserFloatingLayer />
          <View className="mtitle">收款账户管理</View>
        </View> */}
        <View className="mlist">
          {
            list.length > 0
              ? list?.map(item =>
                <View className="mitem" key={item.aid}>
                  <View className="edit" onClick={this.editAccount.bind(this, item)}>修改</View>
                  {item.status == 0
                    ? <View className="close" onClick={this.onUpdateStatus.bind(this, item.id)}>设置为默认账户</View>
                    : <View className="closes">默认账户</View>}
                  <View className="formItem">
                    <View className="formName">{item.bank}</View>
                  </View>
                  <View className="formItem">
                    <View className="formName">账户：{item.accounts}</View>
                  </View>
                  <View className="formItem">
                    <View className="formName">开户行：{item.openBank}</View>
                  </View>
                  <View className="formItem">
                    <View className="formName">账户姓名：{item.name}</View>
                  </View>
                </View>
              )
              : <View className="mitems">
                <View className="mitxt">您暂未设置收款账户！</View>
                <View className="mitxt">请点击“新增收款账户”按钮进行添加</View>
              </View>
          }
        </View>
        <View className="mbottom">
          <AtButton
            type="primary"
            circle
            onClick={() => {
              this.setState({ visible: "add" })
            }}
          >+ 新增收款账户</AtButton>
        </View>
        {visible != "" &&
          <AccountModal
            isDefault={list.length == 0 ? true : false}
            data={data}
            visible={visible}
            onClose={this.onClose.bind(this)}
          />}
      </View>
    );
  }
}

export default myInfo;
