import React, { Component } from 'react';
import Taro from '@tarojs/taro';
import { View, Picker, ScrollView, Image, Button } from '@tarojs/components'
import { getRecordList, subMrge } from '../../utils/servers/servers';
import dayjs from 'dayjs';
import { AtIcon, AtSearchBar } from 'taro-ui';
import { getAccountName, getSecondaryAccountName, removeNull, copyText, commonAdd } from '../../utils/tools';
import { accountLtate, } from '../../utils/tools/config'
import ListBottomStart from "../../components/common/listBottomStart";
import AuditModal from "../../components/common/auditModal";
import sels from "../../image/sels.png";
import sel from "../../image/sel.png";

import './index.less';
import 'taro-ui/dist/style/components/tabs.scss';
import "taro-ui/dist/style/components/flex.scss";
import "taro-ui/dist/style/components/action-sheet.scss";
import "taro-ui/dist/style/components/icon.scss";
import "taro-ui/dist/style/components/list.scss";
import "taro-ui/dist/style/components/icon.scss";
import "taro-ui/dist/style/components/modal.scss";

class Examine extends Component {

  constructor(props) {
    super(props);
    this.state = {
      starts: {
        title: '待提交',
        id: 0,
        color: '#f1662f'
      },
      list: [],
      visible: false,
      sublist: [],
      searchType: { title: "按编号", id: 0 },
      search: [
        { title: "按编号", id: 0 },
        { title: "按企业名称", id: 1 },
      ]
    }
  }

  componentDidShow() {
    this.setState({
      visible: false,
    })
    this.getPublicReleaseList();
  }

  // async componentDidMount() {
  //   await this.getPublicReleaseList();
  // }

  onPullDownRefresh() {
    this.getPublicReleaseList();
  }

  onReachBottom() {
    this.getPublicReleaseList(true);
  }

  onTabItemTap(obj) {
    if (obj.index === 1) {
      this.onTabTap();
    }
  }

  onPickerHide() {
    this.setState({
      isPickerRender: false,
    });
  }


  async onSetPickerTime(val) {
    let data = val.detail;
    await this.setState({
      rangeStartMinuteVal: dayjs(data.selectStartTime).format("YYYY-MM-DD"),
      rangeEndMinuteVal: dayjs(data.selectEndTime).format("YYYY-MM-DD")
    })
    await this.getMyList(1);
  }

  async onTabTap() {
    await this.getMyList(1);
  }

  async getPublicReleaseList(lv) {
    await this.getMyList(lv ? this.state.pageNo + 1 : 1);
    Taro.stopPullDownRefresh();
  }

  async getMyList(pageNo) {
    this.setState({
      listState: 'LOADING'
    })
    let data = {
      pageNo: pageNo,
      pageSize: 10,
      startTime: this.state.rangeStartMinuteVal || undefined,
      endTime: this.state.rangeEndMinuteVal || undefined,
      status: isNaN(parseInt(this.state.starts.id)) ? undefined : String(this.state.starts.id),
      processStatus: 0,
      username: this.state.searchType.id == 1 ? this.state.searchValue : undefined,
      checkNo: this.state.searchType.id == 0 ? this.state.searchValue : undefined,
    }
    let msg = await getRecordList(removeNull(data));
    if (msg.error.length === 0) {
      if (msg.data.totalCount === 0) {
        this.setState({
          listState: 'NO_DATA'
        })
      } else if (msg.data.totalCount === this.state.list.length && pageNo !== 1) {
        Taro.showToast({ title: '没有更多数据了', icon: 'none' });
        this.setState({
          listState: 'NO_MORE_DATA'
        })
      } else {
        if (msg.data.totalCount === (pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list)).length) {
          this.setState({
            listState: 'NO_MORE_DATA'
          })
        }
      }
      this.setState({
        list: pageNo === 1 ? msg.data.list : this.state.list.concat(msg.data.list),
        pageNo: msg.data.list.length === 0 ? this.state.pageNo : msg.data.pageNo
      })
    } else {
      Taro.showToast({ title: msg.error[0].message, icon: 'none' });
      this.setState({
        listState: msg.error[0].field === '403' ? 'NO_DATA' : 'RELOAD'
      })
    }
    Taro.stopPullDownRefresh();
  }

  onPageScroll(event) {
    let touchMove = event.scrollTop;
    if (touchMove >= 37) {
      this.setState({
        openSearch: true
      })
    } else {
      this.setState({
        openSearch: false
      })
    }
  }

  onChecked(item) {
    let list = this.state.sublist
    list.includes(item.id)
      ? list = list.filter(function (value) {
        return value !== item.id;
      }, this)
      : list.push(item.id)
    this.setState({
      sublist: list
    })
  }

  onAllCheck() {
    const { list, } = this.state
    let nlist = this.state.sublist
    if (list.length == nlist.length) {
      nlist = []
    } else {
      nlist = list.map(i => i.id)
    }
    this.setState({
      sublist: nlist
    })
  }

  getAmount(slist) {

    const { list } = this.state
    let xlist = []
    let amount = 0
    for (var i = 0; i < list.length; i++) {
      for (var j = 0; j < slist.length; j++) {
        if (list[i].id == slist[j]) {
          xlist.push(list[i])
        }
      }
    }
    for (var k = 0; k < xlist.length; k++) {
      amount = commonAdd(amount, xlist[k].realAmount)
    }
    return amount
  }

  subMerge() {
    let data = {
      ids: this.state.sublist.toString()
    }
    this.setState({
      loading: true,
    });
    subMrge(data)
      .then((v) => {
        this.setState({
          loading: false,
        })
        if (v.error.length === 0) {
          this.setState({
            sublist: []
          })
          Taro.navigateTo({
            url: '/pages/mergedetail/index?id=' + v.data,
          });
        } else {
          Taro.showToast({
            title: v.error[0].message,
            icon: "none",
          });
        }
      })
      .catch(() => {
        this.setState({
          loading: false,
        });
      });
  }


  render() {
    const { list, sublist, searchType, search } = this.state
    return (
      <View className='indexPage' >
        <View className='searchContent'>
          <View className='searchTop'>
            <Picker
              value={searchType.id}
              range={search} rangeKey='title' mode='selector'
              onChange={(e) => {
                this.setState({
                  searchType: search[e.detail.value],
                })
              }}>
              <View className='shortValuecontent'>
                <View className='selectTitle'>{searchType.title}</View>
                <View className='iconContent'><AtIcon value='chevron-down' size='10' color='#FFFFFF' /></View>
              </View>
            </Picker>
            <AtSearchBar
              showActionButton
              placeholder='请输入'
              value={this.state.searchValue}
              onActionClick={() => {
                this.getPublicReleaseList();
              }}
              onChange={(value) => {
                this.setState({
                  searchValue: value
                })
              }}
              onClear={() => {
                this.setState({
                  searchValue: ''
                })
              }}
            />
          </View>
          <ScrollView className={this.state.openSearch ? 'searchBottomLOL' : ''} scrollX style={{ width: '100%' }}>
            <View className='searchBottom'>
              <View className='searchItem' style={{ paddingLeft: '5px' }}>
                <Picker
                  value={this.state.starts.id}
                  range={accountLtate} rangeKey='title' mode='selector'
                  onChange={(e) => {
                    this.setState({
                      starts: accountLtate[e.detail.value],
                    }, () => {
                      this.getPublicReleaseList();
                    })
                  }}>
                  {
                    !this.state.starts.title ?
                      <View className='shortValuecontent'>
                        <View className='selectTitle'>状态</View>
                        <View className='iconContent'><AtIcon value='chevron-down' size='10' color='#FFFFFF' /></View>
                      </View> :
                      <View className='shortValuecontent'>
                        <View className='selectValue'>
                          {this.state.starts.title}
                        </View>
                        <View className='iconContent' />
                      </View>
                  }
                </Picker>
                {
                  this.state.starts.title &&
                  <View className='searchSelectContent'>
                    <View className='selectIcon'
                      onClick={(e) => {
                        e.stopPropagation();
                        this.setState({
                          starts: {}
                        }, () => {
                          this.getPublicReleaseList();
                        })
                      }}>
                      <AtIcon value='close-circle' size='10' color='#FFFFFF' />
                    </View>
                  </View>
                }
              </View>
              <View className='searchItem' onClick={() => {
                this.setState({
                  isPickerRender: true
                })
              }}>
                <View>
                  {
                    !this.state.rangeStartMinuteVal ?
                      <View className='valuecontent'>
                        <View className='selectTitle'>开始及结束时间</View>
                        <View className='iconContent' ><AtIcon value='chevron-down' size='10' color='#FFFFFF' /></View>
                      </View> :
                      <View className='valuecontent'>
                        <View className='selectValue' >
                          {this.state.rangeStartMinuteVal + "~" + this.state.rangeEndMinuteVal}
                        </View>
                        <View className='iconContent' />
                      </View>
                  }
                </View>
                {
                  this.state.rangeStartMinuteVal &&
                  <View className='searchSelectContent'>
                    <View className='selectIcon'
                      onClick={(e) => {
                        e.stopPropagation();
                        this.setState({
                          rangeStartMinuteVal: '',
                          rangeEndMinuteVal: '',
                        }, () => {
                          this.getPublicReleaseList();
                        })
                      }}>
                      <AtIcon value='close-circle' size='10' color='#FFFFFF' />
                    </View>
                  </View>
                }
              </View>
            </View>
          </ScrollView>
        </View>
        <View className='list'>
          {
            list?.map((item) =>
              <View className='item' key={item.id}
                onClick={() => {
                  (item.status == 0 || item.status == 3) ?
                    Taro.navigateTo({
                      url: '/pages/drafts/index?id=' + item.id
                    }) :
                    Taro.navigateTo({
                      url: '/pages/draftsdetail/index?id=' + item.id
                    })
                }}
              >
                <View className='left'
                  onClick={e => {
                    e.stopPropagation();
                    item.status == 0
                      ? this.onChecked(item)
                      : Taro.showToast({ title: '只能选择待提交的费用！', icon: 'none' })
                  }}>
                  <Image className='check' src={sublist.includes(item.id) ? sels : sel} />
                </View>
                <View className='right'>
                  {/* {item.status == 1 && <View className='lbt' onClick={e => { e.stopPropagation(); this.setState({ visible: true, id: item.id }) }}>查看审核详情</View>} */}
                  <View className='line' style={{ color: "#6190E8" }}>报销金额：{item.realAmount}（元）</View>
                  {!!item.checkNo && <View className='line' style={{ color: "#6190E8" }}>报销编号：{item.checkNo}</View>}
                  {!!item.checkNo && <View className='lbt' onClick={e => { e.stopPropagation(); copyText(item.checkNo) }}>复制编号</View>}
                  <View className='line'>
                    报销类型：
                    {getAccountName(item.type, item.typeOther)}
                    {item.type == 2 && (" - " + getSecondaryAccountName(item.secondaryType, item.secondaryTypeOther))}
                  </View>
                  {/* {<View className='line'>报销至订单：{item.contractNo || "固定费用"}</View>} */}
                  {!!item.applyDepName && <View className='line'>报销至部门：{item.applyDepName}</View>}
                  {item.type == 1 && <View className='line'>公出企业：{item.userNames}</View>}
                  <View className='line'>
                    {item.type == 1 ? "公出时间" : "费用时间"}：
                    {!item.releaseStartStr ? "" : (item.releaseStartStr.slice(0, 10) + " 至 " + item.releaseEndStr.slice(0, 10))}
                  </View>
                  <View className='lines'
                    style={{ color: accountLtate[item.status].color }}
                  >
                    {/* {item.status == 1 && `[${item.examineName}]`} */}
                    {accountLtate[item.status].title}
                  </View>
                </View>
              </View>
            )
          }
          <ListBottomStart
            state={this.state.listState}
            reload={() => {
              this.getPublicReleaseList(true)
            }}
          />
        </View>
        {
          list.length > 0 &&
          <View className='bottom'>
            <View className='lbt'>
              {this.state.starts.id == 0 &&
                <View className='lbtxt'
                  onClick={() => {
                    this.onAllCheck()
                  }}
                >
                  <Image className='lbtck' src={list.length == sublist.length ? sels : sel} />
                  全选
                </View>}
              报销金额：{this.getAmount(sublist)}元
            </View>
            <Button
              disabled={sublist.length == 0}
              className='rbt'
              type='primary'
              onClick={() => { this.subMerge() }}
            >可多选，发起报销</Button>
          </View>
        }
        <timePicker
          config={{
            endDate: true,
            column: "day",
            dateLimit: false,
            limitStartTime: dayjs().subtract(3, 'year').format('YYYY-MM-DD '),
            limitEndTime: dayjs().add(3, 'year').format('YYYY-MM-DD ')
          }}
          isPartition
          pickerShow={this.state.isPickerRender}
          onconditionaljudgment={(v) => {
          }}
          onhidepicker={() => {
            this.onPickerHide()
          }}
          onsetpickertime={(v) => {
            this.onSetPickerTime(v)
          }}>
        </timePicker>
        {
          this.state.visible &&
          <AuditModal
            id={this.state.id}
            isOpened={this.state.visible}
            onClose={() => {
              this.setState({
                visible: false
              })
            }}
          />
        }
      </View >
    )
  }
}

export default Examine
